unit ZINSegUnit;

interface
uses
  bsHL7Object,BSHL7DT24;

type
  TbsZIN_24 = class(TBSHL7Segment)
  private
    function Getcondition: TbsST_24;
    function Getifcondition: TbsST_24;
    procedure Setcondition(const Value: TbsST_24);
    procedure Setifcondition(const Value: TbsST_24);
  public
    property ifcondition : TbsST_24 read Getifcondition write Setifcondition;
    property condition : TbsST_24 read Getcondition write Setcondition;
    procedure Init;override;
  end;


implementation

{ TbsZIN_24 }

function TbsZIN_24.Getcondition: TbsST_24;
begin
   Result:= TbsST_24(GetOrCreateObject('CONDITION'));
end;

function TbsZIN_24.Getifcondition: TbsST_24;
begin
   Result:= TbsST_24(GetOrCreateObject('IFCONDITION'));
end;

procedure TbsZIN_24.Init;
begin
  SetType('ZIN','2.4','BESA');
  inherited;
end;

procedure TbsZIN_24.Setcondition(const Value: TbsST_24);
begin
  SetObject('CONDITION',Value);
end;

procedure TbsZIN_24.Setifcondition(const Value: TbsST_24);
begin
  SetObject('IFCONDITION',Value);
end;

procedure InitZINSegment;
var
  LDefinition : TBSHL7Definition;
begin
  LDefinition := TBSHL7Definition.Create('ZIN','2.4','BESA','S');
  BSHL7Library.AddType(LDefinition);
  LDefinition.Add('IFCONDITION','ST',0,1);
  LDefinition.Add('CONDITION','ST',0,1);
end;

initialization
  InitZINSegment;


end.
