unit ZPI_Z01MsgUnit;

interface
uses
  bsHL7Object,
  ZINSegUnit,
  ZAUSegUnit,
  BSHL7DT24;

type
  TBSZPI_Z01_24 = class(TBSHL7Message)
  private
    function GetIN1: TbsIN1_24;
    function GetMSH: TbsMSH_24;
    function GetPID: TbsPID_24;
    function GetPRD: TbsPRD_24;
    function GetZAU: TbsZAU_24;
    function GetZIN: TbsZIN_24;
    procedure SetIN1(const Value: TbsIN1_24);
    procedure SetMSH(const Value: TbsMSH_24);
    procedure SetPID(const Value: TbsPID_24);
    procedure SetPRD(const Value: TbsPRD_24);
    procedure SetZAU(const Value: TbsZAU_24);
    procedure SetZIN(const Value: TbsZIN_24);
  public
   procedure Init; override;
   property MSH : TbsMSH_24 read GetMSH write SetMSH;
   property ZAU : TbsZAU_24 read GetZAU write SetZAU;
   property PRD : TbsPRD_24 read GetPRD write SetPRD;
   property PID : TbsPID_24 read GetPID write SetPID;
   property IN1 : TbsIN1_24 read GetIN1 write SetIN1;
   property ZIN : TbsZIN_24 read GetZIN write SetZIN;
  end;

implementation

{ TBSZPI_Z01_24 }

function TBSZPI_Z01_24.GetIN1: TbsIN1_24;
begin
  Result:=TbsIN1_24(GetOrCreateObject('IN1'));
end;

function TBSZPI_Z01_24.GetMSH: TbsMSH_24;
begin
  Result:=TbsMSH_24(GetOrCreateObject('MSH'));
end;

function TBSZPI_Z01_24.GetPID: TbsPID_24;
begin
  Result:=TbsPID_24(GetOrCreateObject('PID'));
end;

function TBSZPI_Z01_24.GetPRD: TbsPRD_24;
begin
  Result:=TbsPRD_24(GetOrCreateObject('PRD'));
end;

function TBSZPI_Z01_24.GetZAU: TbsZAU_24;
begin
  Result:=TbsZAU_24(GetOrCreateObject('ZAU'));
end;

function TBSZPI_Z01_24.GetZIN: TbsZIN_24;
begin
  Result:=TbsZIN_24(GetOrCreateObject('ZIN'));
end;

procedure TBSZPI_Z01_24.Init;
begin
   FTypeName:='ZPI_Z01';
   FTypeVersion:='24';
   FTypeVendor:='BESA';
   inherited;
end;

procedure TBSZPI_Z01_24.SetIN1(const Value: TbsIN1_24);
begin
   SetObject('IN1',Value);
end;

procedure TBSZPI_Z01_24.SetMSH(const Value: TbsMSH_24);
begin
   SetObject('MSH',Value);
end;

procedure TBSZPI_Z01_24.SetPID(const Value: TbsPID_24);
begin
   SetObject('PID',Value);
end;

procedure TBSZPI_Z01_24.SetPRD(const Value: TbsPRD_24);
begin
   SetObject('PRD',Value);
end;

procedure TBSZPI_Z01_24.SetZAU(const Value: TbsZAU_24);
begin
   SetObject('ZAU',Value);
end;

procedure TBSZPI_Z01_24.SetZIN(const Value: TbsZIN_24);
begin
   SetObject('ZIN',Value);
end;

procedure InitZPI_Z01Message;
var
  LDefinition : TBSHL7Definition;
begin
  LDefinition := TBSHL7Definition.Create('ZPI_Z01','2.4','BESA','M');
  BSHL7Library.AddType(LDefinition);
  LDefinition.Add('MSH','MSH',1,1);
  LDefinition.Add('MSA','MSA',0,1);
  LDefinition.Add('ZAU','ZAU',0,1,'BESA');
  LDefinition.Add('PRD','PRD',0,1);
  LDefinition.Add('PID','PID',0,1);
  LDefinition.Add('IN1','IN1',0,1);
  LDefinition.Add('ZIN','ZIN',0,1,'BESA');
end;

initialization
  InitZPI_Z01Message;

end.
